module Greet

data Vehicle = Car | Motorcycle

possiblyVehicle : Nat -> Type
possiblyVehicle n = if n < 18 then () else Vehicle

data Person : Type where
  MkPerson
    :  (age : Nat)
    -> (v : possiblyVehicle age)
    -> Person

greet : Person -> String
greet (MkPerson age v) with (age < 18)
  greet (MkPerson _ ())         | True  =
    "Be patient, you're not old enough to drive!"
  greet (MkPerson _ Car)        | False =
    "Hello, you car driver!"
  greet (MkPerson _ Motorcycle) | False =
    "Hello, you motorcycle driver!"
